#!/bin/sh

#
# A replacement for lpr, using ssh as a communications backend.
# roessler@guug.de, 1997-01-20
#

HOSTNAME=`hostname`
PRINTSERVER=localhost
SSH=/usr/local/ssh/bin/ssh
SCP=/usr/local/ssh/bin/scp
CWD=`pwd`
umask 077

[ -z "$TMPDIR" ] && TMPDIR=/tmp

[ -f /etc/lpr.conf ] && . /etc/lpr.conf
[ -f $HOME/.lprrc ] && . $HOME/.lprrc

LTMP=$TMPDIR/lpr-l.$$
RTMP=/tmp/lpr-r.$HOSTNAME.$$

trap "rm -rf $LTMP ; $SSH $PRINTSERVER rm -rf $RTMP ; trap '' 0 ; exit 1" 0 1 2 3

mkdir $LTMP || exit 1
$SSH $PRINTSERVER "umask 077 ; mkdir $RTMP" || exit 1

havearg="no"
haveinput="no"
args=""

for i in "$@" ; do
	if [ $havearg = "yes" ] ; then
		havearg="no"
		args="$args $i"
		continue
	fi
	
	case "$i" in
	-P*)	[ "$i" = "-P" ] && havearg="yes"
		args="$args $i"
		;;
	-\#*)	[ "$i" = "-#" ] && havearg="yes"
		args="$args $i"
		;;
	-C*)	[ "$i" = "-C" ] && havearg="yes"
		args="$args $i"
		;;
	-J*)	[ "$i" = "-J" ] && havearg="yes"
		args="$args $i"
		;;
	-T*)	[ "$i" = "-T" ] && havearg="yes"
		args="$args $i"
		;;
	-U*)	[ "$i" = "-U" ] && havearg="yes"
		args="$args $i"
		;;
	-i*)	[ "$i" = "-I" ] && havearg="yes"
		args="$args $i"
		;;
	-[1234]*)
		expr match "$i" "-[1234]$" > /dev/null && havearg="yes"
		args="$args $i"
		;;
        -w*)	[ "$i" = "-w" ] && havearg="yes"
		args="$args $i"
		;;
        -[cdfghlnmprstv]*)
		args="$args $i"
		;;
	-*)	args="$args $i"
		;;
	*)	rfilename=//${HOSTNAME}${CWD}/"$i"
		rfilename="${RTMP}/`echo $rfilename | tr '/' '!'`"
		echo -n "Transferring $i to ${PRINTSERVER}:$rfilename... "
		$SCP $i ${PRINTSERVER}:$rfilename	\
			|| exit 1
		echo "done."
		args="$args $rfilename"
		haveinput="yes"
		;;
	esac
done

$SSH $PRINTSERVER "lpr $args"
